class Temperatures
  SLOPEFAHRENHEIT = 9.0 / 5.0
  OFFSETFAHRENHEIT = 32.0
  KELVINOFFSET = 273.15
  attr_accessor :kelvin

  #Constructor that it passes by parameter the hash value to know what type of temperature we have selected in the line argument
  def initialize(value = 0)
    if value[:celsius]
      self.celsius = value[:celsius]
    elsif value[:fahrenheit]
      self.fahrenheit = value[:fahrenheit]
    elsif value[:kelvin]
      self.kelvin = value[:kelvin]
    else
      raise "No temperature unit given in temperature hash"
    end
  end

  #Method to have only one variable in the class to save the temperature. We use Kelvin. For this reason, we convert celsius to kelvin
  def celsius= (value)
    @kelvin = value + KELVINOFFSET
  end
  #Method to have only one variable in the class to save the temperature. We use Kelvin. For this reason, we convert fahrenheit to kelvin
  def fahrenheit=value
    @kelvin = ((value - OFFSETFAHRENHEIT) / SLOPEFAHRENHEIT) + KELVINOFFSET
  end
  #Method to return the actual value of degrees celsisus
  def to_celsius
    kelvin - KELVINOFFSET
  end
  #Method to return the actual value of degrees kelvin
  def to_kelvin
    kelvin
  end
  #Method to return the actual value of degrees fahrenheit
  def to_fahrenheit
    ((kelvin- KELVINOFFSET) * SLOPEFAHRENHEIT) + OFFSETFAHRENHEIT
  end

end
